Communities

Writing
Writing
Codidact Meta
Codidact Meta
The Great Outdoors
The Great Outdoors
Photography & Video
Photography & Video
Scientific Speculation
Scientific Speculation
Cooking
Cooking
Electrical Engineering
Electrical Engineering
Judaism
Judaism
Languages & Linguistics
Languages & Linguistics
Software Development
Software Development
Mathematics
Mathematics
Christianity
Christianity
Code Golf
Code Golf
Music
Music
Physics
Physics
Linux Systems
Linux Systems
Power Users
Power Users
Tabletop RPGs
Tabletop RPGs
Community Proposals
Community Proposals
tag:snake search within a tag
answers:0 unanswered questions
user:xxxx search by author id
score:0.5 posts with 0.5+ score
"snake oil" exact phrase
votes:4 posts with 4+ votes
created:<1w created < 1 week ago
post_type:xxxx type of post
Search help
Notifications
Mark all as read See all your notifications »
Q&A

Comments on trap ... ERR, how to get the signal code?

Parent

trap ... ERR, how to get the signal code?

+0
−0

Inspired by https://software.codidact.com/posts/294883 , I had a look at shell scripting (bash).

I have little experience there as I prefer (long) one-liners.

For trap there is some kind of wildcard, ERR.

How to get the actual signal code?

History

0 comment threads

Post
+1
−0

ERR is not a signal, so there is no signal code to get. From man bash:

If a sigspec is ERR, the command arg is executed whenever a pipeline (which may consist of a single simple command), a list, or a compound command returns a non-zero exit status, subject to the following conditions. The ERR trap is not executed if the failed command is part of the command list immediately following a while or until keyword, part of the test in an if statement, part of a command executed in a && or || list except the command following the final && or ||, any command in a pipeline but the last, or if the command's return value is being inverted using !. These are the same conditions obeyed by the errexit (-e) option.

History

1 comment thread

How can the causing RC be seen? (4 comments)
How can the causing RC be seen?
watchmaker‭ wrote 11 months ago

So my misunderstanding boils down that ERR is not a wildcard for a signal, but traps any non-zero RC (that is not enclosed by some sub-shell)?

If so, how can the causing RC be seen?

r~~‭ wrote 11 months ago

You can always get the exit status of the last command with $?.

watchmaker‭ wrote 11 months ago

Doesn't work for me.

trap "echo The script is terminated by err=$?; exit 3" ERR prints The script is terminated by err=0 .

So, true to your words, it is "the exit status of the last command", not of the one caught in the trap.

r~~‭ wrote 11 months ago

This is a whole separate question about when parameter substitution happens, but you'll notice that the behavior changes when you replace your double quotes with singles.